using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace NetworkTest
{
    class ObjectSprite : Sprite
    {
        public Texture2D Texture
        {
            get
            {
                return mTexture;
            }
            set
            {
                mTexture = value;
                mOrigin = new Vector2(mTexture.Width / 2, mTexture.Height / 2);
            }
        }

        private Vector2 mOrigin;
        private Texture2D mTexture;

        public ObjectSprite(Texture2D texture)
        {            
            Position = Vector2.Zero;
            Color = Color.White;
            Scale = 1;
            Alpha = 255;
            Texture = texture;
            mOrigin = new Vector2(texture.Width / 2, texture.Height / 2);
        }
        public override void Draw(SpriteBatch sb)
        {
            sb.Draw(mTexture, Position, null, Color, Rotation, mOrigin, Scale, SpriteEffects.None, 0);
        }

        public Vector2 Origin()
        {
            return mOrigin;
        }
        public override Vector2 Size()
        {
            return new Vector2(mTexture.Width, mTexture.Height);
        }

    }
}