using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;


namespace NetworkTest
{
    struct WorldObject
    {
        public WorldObject(ObjectSprite os) 
        {
            mObjectSprite = os;
            mVelocity = Vector2.Zero;
        }
        public ObjectSprite mObjectSprite;
        public Vector2 mVelocity;
    }

    class World
    {
        public WorldObject mMyPaddle;
        public WorldObject mOpponentPaddle;

        public String MyName { get; set; }
        public String OpponentName { get; set; }

        public Vector2 WorldSize { get; set; }


        public World(int width, int height)
        {
            WorldSize = new Vector2(width, height);
        }


        public void Update(GameTime gameTime)
        {
            mMyPaddle.mObjectSprite.Position += mMyPaddle.mVelocity * (float) gameTime.ElapsedGameTime.TotalSeconds;
            mMyPaddle.mObjectSprite.Position = Vector2.Clamp(mMyPaddle.mObjectSprite.Position, mMyPaddle.mObjectSprite.Origin(), WorldSize - mMyPaddle.mObjectSprite.Origin());

            // Update ball, too!
            // Update opponent paddle?
        }



        public void InitializeWorld(bool isHost)
        {
            if (isHost)
            {
                mMyPaddle.mObjectSprite.Position = mMyPaddle.mObjectSprite.Origin();
                mOpponentPaddle.mObjectSprite.Position = WorldSize - mOpponentPaddle.mObjectSprite.Origin();
            }
            else
            {
                mOpponentPaddle.mObjectSprite.Position = mOpponentPaddle.mObjectSprite.Origin();
                mMyPaddle.mObjectSprite.Position = WorldSize - mMyPaddle.mObjectSprite.Origin();
            }
        }


        public void Draw(SpriteBatch sb)
        {
            mMyPaddle.mObjectSprite.Draw(sb);
            mOpponentPaddle.mObjectSprite.Draw(sb);
            // Draw ball, too!
        }



        public void LoadContent(Microsoft.Xna.Framework.Content.ContentManager Content)
        {
            Texture2D paddleTexture = Content.Load<Texture2D>("paddle");
            mMyPaddle = new WorldObject(new ObjectSprite(paddleTexture));
            mOpponentPaddle = new WorldObject(new ObjectSprite(paddleTexture));
        }
    }
}